blob: 90af2bc40481a4e83f895db69199fb8841cf892f [file] [log] [blame]
Victor Morales89ce3212017-06-16 18:32:48 -05001#!/bin/bash
2
3set -o xtrace
4
5source /var/onap/commons
Victor Moralesdd074802017-07-26 16:06:35 -05006source /var/onap/_composed_functions
7source /var/onap/_onap_functions
8
Victor Morales96512652017-08-16 13:44:28 -05009export MTU=$(/sbin/ifconfig | grep MTU | sed 's/.*MTU://' | sed 's/ .*//' |sort -n | head -1)
10export IP_ADDRESS=$(ifconfig eth0 | grep "inet addr" | tr -s ' ' | cut -d' ' -f3 | cut -d':' -f2)
11
Victor Moralesdd074802017-07-26 16:06:35 -050012mvn_conf_file=/root/.m2/settings.xml
13git_src_folder=/opt
14
Victor Morales89ce3212017-06-16 18:32:48 -050015# configure_dns() - DNS/GW IP address configuration
16function configure_dns {
17 echo "nameserver 10.0.0.1" >> /etc/resolvconf/resolv.conf.d/head
18 resolvconf -u
19}
20
Victor Moralesdd074802017-07-26 16:06:35 -050021# _git_timed() - git can sometimes get itself infinitely stuck with transient network
Victor Morales89ce3212017-06-16 18:32:48 -050022# errors or other issues with the remote end. This wraps git in a
23# timeout/retry loop and is intended to watch over non-local git
24# processes that might hang.
Victor Moralesdd074802017-07-26 16:06:35 -050025function _git_timed {
Victor Morales89ce3212017-06-16 18:32:48 -050026 local count=0
27 local timeout=0
28
29 install_package git
30 until timeout -s SIGINT ${timeout} git "$@"; do
31 # 124 is timeout(1)'s special return code when it reached the
32 # timeout; otherwise assume fatal failure
33 if [[ $? -ne 124 ]]; then
34 exit 1
35 fi
36
37 count=$(($count + 1))
38 if [ $count -eq 3 ]; then
39 exit 1
40 fi
41 sleep 5
42 done
43}
44
45# clone_repo() - Clone Git repository into specific folder
46function clone_repo {
47 local repo_url=https://git.onap.org/
48 local repo=$1
Victor Moralesdd074802017-07-26 16:06:35 -050049 local dest_folder=${2:-$git_src_folder/$repo}
50 if [ ! -d $dest_folder ]; then
Victor Morales96512652017-08-16 13:44:28 -050051 _git_timed clone ${repo_url}${repo} $dest_folder
Victor Morales89ce3212017-06-16 18:32:48 -050052 else
53 pushd $dest_folder
Victor Moralesdd074802017-07-26 16:06:35 -050054 _git_timed pull
Victor Morales89ce3212017-06-16 18:32:48 -050055 popd
56 fi
57}
58
59# install_dev_tools() - Install basic dependencies
60function install_dev_tools {
61 install_package apt-transport-https
62 install_package ca-certificates
63 install_package curl
64}
65
Victor Moralesdd074802017-07-26 16:06:35 -050066# _install_bind() - Install bind utils
67function _install_bind {
Victor Morales89ce3212017-06-16 18:32:48 -050068 install_package bind9
69 install_package bind9utils
70}
71
Victor Morales89ce3212017-06-16 18:32:48 -050072# install_java() - Install java binaries
73function install_java {
Victor Moralesece790c2017-08-08 11:11:36 -050074 if is_package_installed openjdk-8-jdk; then
75 return
76 fi
Victor Morales89ce3212017-06-16 18:32:48 -050077 install_package software-properties-common
78 add-apt-repository -y ppa:openjdk-r/ppa
79 install_package openjdk-8-jdk
Victor Morales455bece2017-07-31 18:40:39 -050080 # ca-certificates-java is not a dependency in the Oracle JDK/JRE so this must be explicitly installed.
81 /var/lib/dpkg/info/ca-certificates-java.postinst configure
Victor Morales89ce3212017-06-16 18:32:48 -050082}
83
84# install_maven() - Install maven binaries
85function install_maven {
Victor Moralesdd074802017-07-26 16:06:35 -050086 if is_package_installed maven3; then
Victor Morales89ce3212017-06-16 18:32:48 -050087 return
88 fi
Victor Moralesece790c2017-08-08 11:11:36 -050089 install_java
Victor Morales89ce3212017-06-16 18:32:48 -050090 install_package software-properties-common
91 add-apt-repository -y ppa:andrei-pozolotin/maven3
92 install_package maven3
93
94 # Force Maven3 to use jdk8
95 apt-get purge openjdk-7-jdk -y
Victor Moralesdd074802017-07-26 16:06:35 -050096
97 _configure_maven
Victor Morales89ce3212017-06-16 18:32:48 -050098}
99
Victor Moralesdd074802017-07-26 16:06:35 -0500100# _configure_docker_proxy() - Configures proxy in Docker from ENV
101function _configure_docker_proxy {
Victor Morales89ce3212017-06-16 18:32:48 -0500102 if [ $http_proxy ]; then
103 echo "export http_proxy=$http_proxy" >> /etc/default/docker
104 fi
105 if [ $https_proxy ]; then
106 echo "export https_proxy=$https_proxy" >> /etc/default/docker
107 fi
108}
109
Victor Moralesdd074802017-07-26 16:06:35 -0500110# install_nodejs() - Download and install NodeJS
111function install_nodejs {
112 if is_package_installed nodejs; then
113 return
114 fi
115 curl -sL https://deb.nodesource.com/setup_6.x | sudo -E bash -
116 install_package nodejs
117
118 # Update NPM to latest version
119 npm install npm -g
120}
121
122# install_python() - Install Python 2.7 and other tools necessary for development.
123function install_python {
124 install_package python2.7
125 install_package python-dev
Victor Moralesdd074802017-07-26 16:06:35 -0500126}
127
Victor Morales970ec192017-07-31 09:10:11 -0500128# _install_pip() - Install Python Package Manager
129function _install_pip {
130 install_python
Victor Morales158c18c2017-08-06 11:23:15 -0500131 if [ ! -f /usr/local/bin/pip ]; then
132 curl -sL https://bootstrap.pypa.io/get-pip.py | python
133 fi
Victor Morales970ec192017-07-31 09:10:11 -0500134}
135
136# install_python_package() - Install a python module
137function install_python_package {
138 local python_package=$1
139
140 _install_pip
141 pip install $python_package
142}
143
144# install_docker() - Download and install docker-engine
Victor Moralesdd074802017-07-26 16:06:35 -0500145function install_docker {
146 if is_package_installed docker-ce; then
147 return
148 fi
149 install_package software-properties-common
150 curl -fsSL https://download.docker.com/linux/ubuntu/gpg | sudo apt-key add -
151 add-apt-repository \
152 "deb [arch=amd64] https://download.docker.com/linux/ubuntu \
153 $(lsb_release -cs) \
154 stable"
155 install_package docker-ce
156 _configure_docker_proxy
157 service docker restart
158 sleep 10
159}
160
161# pull_docker_image() - Pull Docker container image from the Public Docker Registry Hub
162function pull_docker_image {
163 install_docker
164 local image=$1
165 local tag=$2
166 docker pull ${image}
167 if [ ${tag} ]; then
168 docker tag ${image} $tag
169 fi
170}
171
172# install_docker_compose() - Download and install docker-engine
173function install_docker_compose {
174 local docker_compose_version=${1:-1.12.0}
175 if [ ! -d /opt/docker ]; then
176 mkdir /opt/docker
177 curl -L https://github.com/docker/compose/releases/download/$docker_compose_version/docker-compose-`uname -s`-`uname -m` > /opt/docker/docker-compose
178 chmod +x /opt/docker/docker-compose
179 fi
180}
181
182# _install_ODL() - Download and Install OpenDayLight SDN controller
183function _install_ODL {
184 if [ ! -d /opt/opendaylight/current ]; then
185 mkdir -p /opt/opendaylight/
186 wget "https://nexus.opendaylight.org/content/repositories/public/org/opendaylight/integration/distribution-karaf/"$odl_version"/distribution-karaf-"$odl_version".tar.gz" -P /opt/
187 tar xvf "/opt/distribution-karaf-"$odl_version".tar.gz" -C /opt/
188 mv "/opt/distribution-karaf-"$odl_version /opt/opendaylight/current
189 rm -rf "/opt/distribution-karaf-"$odl_version".tar.gz"
190 fi
191}
192
193# start_ODL() - Start OpenDayLight SDN controller
194function start_ODL {
195 _install_ODL
196 if [ -d /opt/opendaylight ]; then
197 export JAVA_HOME=/usr/lib/jvm/java-8-openjdk-amd64/jre
198 /opt/opendaylight/current/bin/start
199 sleep 180
200 /opt/opendaylight/current/bin/client feature:install odl-dlux-all
201 fi
202}
203
204# compile_src() - Function that compiles the java source code thru maven
205function compile_src {
206 local src_folder=$1
207 pushd $src_folder
208 if [ -f pom.xml ]; then
209 install_maven
Victor Morales970ec192017-07-31 09:10:11 -0500210 mvn clean install -DskipTests=true -Dmaven.test.skip=true -Dmaven.javadoc.skip=true -Dadditionalparam=-Xdoclint:none
Victor Moralesdd074802017-07-26 16:06:35 -0500211 fi
212 popd
213}
214
Victor Morales89ce3212017-06-16 18:32:48 -0500215# build_docker_image() - Build Docker container image from source code
216function build_docker_image {
217 local src_folder=$1
218 local profile=$2
219 install_maven
220 install_docker
221 pushd $src_folder
222
223 # Cleanup external repo
224 sed -i 's|${docker.push.registry}/||g' pom.xml
225 local mvn_docker="mvn clean package docker:build"
226 if [ $profile ]; then
227 mvn_docker+=" -P $profile"
228 fi
229 if [ $http_proxy ]; then
Victor Moralesdd074802017-07-26 16:06:35 -0500230 if ! grep -ql "docker.buildArg.http_proxy" pom.xml ; then
231 mvn_docker+=" -Ddocker.buildArg.http_proxy=$http_proxy"
232 fi
233 if ! grep -ql "docker.buildArg.HTTP_PROXY" pom.xml ; then
234 mvn_docker+=" -Ddocker.buildArg.HTTP_PROXY=$http_proxy"
235 fi
Victor Morales89ce3212017-06-16 18:32:48 -0500236 fi
237 if [ $https_proxy ]; then
Victor Moralesdd074802017-07-26 16:06:35 -0500238 if ! grep -ql "docker.buildArg.https_proxy" pom.xml ; then
239 mvn_docker+=" -Ddocker.buildArg.https_proxy=$https_proxy"
240 fi
241 if ! grep -ql "docker.buildArg.HTTPS_PROXY" pom.xml ; then
242 mvn_docker+=" -Ddocker.buildArg.HTTPS_PROXY=$https_proxy"
243 fi
Victor Morales89ce3212017-06-16 18:32:48 -0500244 fi
245 eval $mvn_docker
246 popd
247}